EXE = exercise5_10
C_FLAGS = -Wall -Wextra -Werror -g3
Program = exercise5_10

dbg: debug/$(EXE)

debug/$(EXE): debug/$(Program).o
	g++    $(C_FLAGS) $^ -o $@

debug/$(Program).o: debug/$(Program).s
	g++ -c $(C_FLAGS) $^ -o $@

debug/$(Program).s: debug/$(Program).ii
	g++ -S $(C_FLAGS) $^ -o $@

debug/$(Program).ii: $(Program).cpp
	g++ -E $(C_FLAGS) $^ -o $@

debug/$(Program).ii: | debug

debug:
	mkdir -p debug

clean:
	rm -rf debug *.ii *.s *.o *.out

test: debug/$(EXE)
	@./debug/$(EXE) > test1.out || echo "Test 1 is executing..."
	@diff test1.out test1.expected && echo "\nTEST 1 PASSED\n" || echo "\nTEST 1 FAILED\n"

.PRECIOUS: $(Program).ii $(Program).s
.SECONDARY: $(Program).ii $(Program).s

